//+------------------------------------------------------------------+
//|                                                     channels.mq4 |
//|                                                      Nikolay 7ko |
//|                                               http://www.7ko.org |
//+------------------------------------------------------------------+

#property strict

#property copyright "  SemkoNV@bk.ru"
#property link      "http://www.7ko.org"    //  
class CDebuggerFix { } ExtDebuggerFix;
//      SemkoNV@bk.ru

#property  indicator_chart_window
#property  indicator_buffers 2

//---- indicator parameters


extern int StartBar =0;        //     , 0 -  .
extern int BarAnaliz=400;      //-         .   2000!
extern double k_shirina=4;     //.  
extern int tochnost =50;       //  1- ,  BarAnaliz -. .    -   
extern double filtr = 0.55;    //    ,    0.382-0,618
extern double MinShirina = 0;  //      , (     )
extern double MaxShirina=10000;  //      , (     )
extern bool luch =  true;      //   ; true - , false - 
extern bool maxmin =  true;    //  -        
                               // -true - .       .  k_shirina   ,  100
// -false - .             ( "")
extern bool color_fill =  true;//   

//---- indicator buffers

double     Canals[1000];
double     Shir[];
double     Vertikal[];

double     Shirina[2000];
double     ShirinaU[2000];
double     ShirinaD[2000];
double     CanalR[2000];
double     CanalL[2000];
double     Kanals[20][9];

int preBars=0;
int p[9]={43200,10080,1440,240,60,30,15,5,1};
int FinishL;
int tick=0;
int bar=0;
int b=0;
int key=0;
//datetime x1,x2;
double sumPlus=0;
double sumMinus=0;
double yOptR,yOptL;
int prexL=0;
int prexR=0;
double ma=0;
int  prevxR=-5;
int  prevp=0;
int prevper=-5;
double sum1=0;
double sum2=0;
double curdeltaMax=-10000;
double curdeltaMin=10000;
int Start=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment("");
   ObjectDelete("channels_start");
   for(int i=0;i<20;i++)
     {
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0));
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" UP");
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" DOWN");
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" TRIUP");
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" TRIDown");
      ObjectDelete("Vertical_9_"+DoubleToStr(i,0));
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---- drawing settings
   IndicatorDigits(Digits+1);

//---- indicator buffers mapping
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,Shir);
   SetIndexBuffer(1,Vertikal);
//---- indicator buffers mapping

// SetIndexBuffer(0,Canals);
//   IndicatorDigits(20);

//---- initialization done
   return(INIT_SUCCEEDED);
  }
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//LoadHist();
   int i;
   if(StartBar!=0 && Start==0) Start=StartBar;

//return(0);
//if (preBars == Bars) return(0);
//preBars = Bars;

   int j=AllCanals();
   Canals[0]=j;                                     //  

   if(j>0)
     {
      for(i=0; i<j; i++)
        {
         Canals[7*i+1] = Kanals[i][0];                //
         Canals[7*i+2] = Kanals[i][1];                // i -   
         Canals[7*i+3] = Kanals[i][2];                //  
         Canals[7*i+4] = Kanals[i][3];                //yOptR
         Canals[7*i+5] = Kanals[i][4];               //yOptL
         Canals[7*i+6] = Kanals[i][5]/Point;          //         , .- , . - 
         Canals[7*i+7] = Kanals[i][6];                //    
         Canals[7*i+8] = Kanals[i][7];                // Up
         Canals[7*i+9] = Kanals[i][8];                // Doun
        }
      BildCanals(j);
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   double y;
   int j,i;
   int      window=0;
   datetime ttt;
   if(id==CHARTEVENT_KEYDOWN) key=(int)lparam;
   if(id==CHARTEVENT_MOUSE_MOVE && key==17)//   CTRL
     {
      ChartXYToTimePrice(0,(int)lparam,(int)dparam,window,ttt,y);
      if(ttt!=0) Start=iBarShift(NULL,0,ttt,false);
   //   Comment(lparam,"  ",dparam,"   ",sparam,"  ",ttt);
      //Sleep(1);
      //RefreshRates();
      j=AllCanals();
      Canals[0]=j;                                     //  

      if(j>0)
        {
         for(i=0; i<j; i++)
           {
            Canals[7*i+1] = Kanals[i][0];                //
            Canals[7*i+2] = Kanals[i][1];                // i -   
            Canals[7*i+3] = Kanals[i][2];                //  
            Canals[7*i+4] = Kanals[i][3];                //yOptR
            Canals[7*i+5] = Kanals[i][4];                //yOptL
            Canals[7*i+6] = Kanals[i][5]/Point;          //         , .- , . - 
            Canals[7*i+7] = Kanals[i][6];                //    
            Canals[7*i+8] = Kanals[i][7];                // Up
            Canals[7*i+9] = Kanals[i][8];                // Doun
           }
         BildCanals(j);
         //RedrawProperties();
         //ChartRedraw(0);
        }
     }
  }
//+------------------------------------------------------------------+
/////////////////////////////  ////////////////////////////////
//+------------------------------------------------------------------+

int BildCanals(int j)//      Kanals[20][7]
  {
   string name;
   datetime x1,x2;
   double y1,y2;
   int i;
//int  color_i[]={Red,Tomato,Yellow,LawnGreen,Green,Aqua,MediumBlue,BlueViolet,FireBrick,BurlyWood,DeepPink,SeaGreen};
   int  color_i[]={C'200,0,0',C'200,100,0',C'160,160,0',C'100,200,0',C'0,200,0',C'0,200,100',C'0,180,180',C'0,60,120',C'0,0,200',C'100,0,200',C'160,0,160',C'160,80,120'};
   int color_i2[]={C'80,0,0', C'80,40,0',  C'60,60,0',  C'40,80,0',  C'0,60,0', C'0,70,50',  C'0,50,50',  C'0,20,40', C'0,0,80', C'40,0,80',  C'50,0,60',  C'60,20,50'};
   for(i=j;i<20;i++)
     {
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0));
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" UP");
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" DOWN");
      ObjectDelete("Vertical_9_"+DoubleToStr(i,0));
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" TRIUP");
      ObjectDelete("LineCanal9_"+DoubleToStr(i,0)+" TRIDown");
      Kanals[i][2]=0;
      Kanals[i][1]=0;
      Kanals[i][0]=0;
     }
//Comment("  = ",j);
  // string comm="  = ";
  // comm=comm+(string)j;
  // for(i=0; i<j; i++)
  //   { comm=comm+"\n"+"  "+DoubleToStr((i+1),0)+" :  - "+DoubleToStr(Kanals[i][0],0)+",   -  "+DoubleToStr(Kanals[i][6],0)+"    "+DoubleToStr(Kanals[i][2],0);}
//  Comment(comm);

   for(i=0; i<j; i++)
     {
      x1 = iTime(NULL,0,Start);
      y1 = Kanals[i][3];
      y2 = Kanals[i][4];
      if(iTime(NULL,0,(Bars-1))<=iTime(NULL,(int)Kanals[i][2],(int)Kanals[i][1]))
        {
         x2=iTime(NULL,(int)Kanals[i][2],(int)Kanals[i][1]);
        }
      else
        {
         x2=iTime(NULL,0,(Bars-1));
         if(Kanals[i][6]!=0) y2=y1-((iBarShift(NULL,(int)Kanals[i][2],x2,FALSE)-iBarShift(NULL,(int)Kanals[i][2],x1,FALSE))/Kanals[i][6])*(y1-Kanals[i][4]);
        }

      name="LineCanal9_"+DoubleToStr(i,0);
      if(ObjectFind(name)==-1)
        {
         if(!ObjectCreate(name,OBJ_TREND,0,x2,y2,x1,y1)) Comment(" 0 = ",GetLastError());
         ObjectSet(name,OBJPROP_RAY,FALSE);
         ObjectSet(name,OBJPROP_COLOR,color_i[i]);
         ObjectSet(name,OBJPROP_STYLE,STYLE_DOT);
         ObjectSet(name,OBJPROP_RAY,luch);

         if(maxmin==true)
            ObjectCreate(name+" UP",OBJ_TREND,0,x2,(y2+Point*Kanals[i][7]),x1,(y1+Point*Kanals[i][7]));
         else
            ObjectCreate(name+" UP",OBJ_TREND,0,x2,(y2+k_shirina*Point*Kanals[i][0]),x1,(y1+k_shirina*Point*Kanals[i][0]));
         ObjectSet(name+" UP",OBJPROP_RAY,FALSE);
         ObjectSet(name+" UP",OBJPROP_COLOR,color_i[i]);
         ObjectSet(name+" UP",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet(name+" UP",OBJPROP_RAY,luch);

         if(maxmin==true)
            ObjectCreate(name+" DOWN",OBJ_TREND,0,x2,(y2+Point*Kanals[i][8]),x1,(y1+Point*Kanals[i][8]));
         else
            ObjectCreate(name+" DOWN",OBJ_TREND,0,x2,(y2-k_shirina*Point*Kanals[i][0]),x1,(y1-k_shirina*Point*Kanals[i][0]));
         ObjectSet(name+" DOWN",OBJPROP_RAY,FALSE);
         ObjectSet(name+" DOWN",OBJPROP_COLOR,color_i[i]);
         ObjectSet(name+" DOWN",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet(name+" DOWN",OBJPROP_RAY,luch);

         if(color_fill==true)
           {
            ObjectCreate(name+" TRIUP",OBJ_TRIANGLE,0,x2,(y2+Point*Kanals[i][7]),x1,(y1+Point*Kanals[i][7]),x2,(y2+Point*Kanals[i][8]));
            ObjectSet(name+" TRIUP",OBJPROP_COLOR,color_i2[i]);
            ObjectCreate(name+" TRIDown",OBJ_TRIANGLE,0,x1,(y1+Point*Kanals[i][7]),x1,(y1+Point*Kanals[i][8]),x2,(y2+Point*Kanals[i][8]));
            ObjectSet(name+" TRIDown",OBJPROP_COLOR,color_i2[i]);
           }

         if(!ObjectCreate("Vertical_9_"+DoubleToStr(i,0),OBJ_VLINE,0,x2,8)) Comment(" 0 = ",GetLastError());
         ObjectSet("Vertical_9_"+DoubleToStr(i,0),OBJPROP_COLOR,color_i[i]);
         ObjectSet("Vertical_9_"+DoubleToStr(i,0),OBJPROP_STYLE,STYLE_DOT);
        }
      else
        {
         if(!ObjectMove(name,0,x2,y2)) Comment(" 1 = ",GetLastError());
         if(!ObjectMove(name,1,x1,y1)) Comment(" 2 = ",GetLastError());

         if(maxmin==true)
           {
            ObjectMove(name+" UP",0,x2,y2+Point*Kanals[i][7]);
            ObjectMove(name+" UP",1,x1,y1+Point*Kanals[i][7]);

            ObjectMove(name+" DOWN",0,x2,y2+Point*Kanals[i][8]);
            ObjectMove(name+" DOWN",1,x1,y1+Point*Kanals[i][8]);

            if(color_fill==true)
              {
               ObjectMove(name+" TRIUP",0,x2,(y2+Point*Kanals[i][7]));
               ObjectMove(name+" TRIUP",1,x1,(y1+Point*Kanals[i][7]));
               ObjectMove(name+" TRIUP",2,x2,(y2+Point*Kanals[i][8]));

               ObjectMove(name+" TRIDown",0,x1,(y1+Point*Kanals[i][7]));
               ObjectMove(name+" TRIDown",1,x1,(y1+Point*Kanals[i][8]));
               ObjectMove(name+" TRIDown",2,x2,(y2+Point*Kanals[i][8]));
              }
           }
         else
           {
            ObjectMove(name+" UP",0,x2,y2+k_shirina*Point*Kanals[i][0]);
            ObjectMove(name+" UP",1,x1,y1+k_shirina*Point*Kanals[i][0]);

            ObjectMove(name+" DOWN",0,x2,y2-k_shirina*Point*Kanals[i][0]);
            ObjectMove(name+" DOWN",1,x1,y1-k_shirina*Point*Kanals[i][0]);
           }
        }

     }
   return(0);
  }
////////////////////////////////////////////////////////
int AllCanals()
  {
   int i1=0,i2,i3,jj,sdv,err=0;
   int k=0;
   int i=0;
   int lastper;
   int St,Fin;
   datetime S,F,prevS,CurStart;
   int lastmin;
   double lmin=1000000;
   double premin=0;
//ArrayInitialize(Kanals,0);
   lastper=9;

   CurStart=iTime(NULL,Period(),Start);
   if(Start==0) CurStart=iTime(NULL,1,0);
   int l5=iBarShift(NULL,p[0],CurStart,FALSE)+BarAnaliz;
   if(iBars(NULL,p[0])<l5) l5=iBars(NULL,p[0])-1;
   prevS=iTime(NULL,p[0],l5);
   if (prevS==0) {err=GetLastError(); Print("O iTime ",err," ",(iBarShift(NULL,p[0],CurStart,FALSE)));}
   ArrayInitialize(Vertikal,0);
   ArrayInitialize(Shir,0);

   for(jj=0;jj<lastper;jj++)
     {
      //ArrayInitialize(Shirina,0);
      if(jj==8) //   
         S = CurStart;
      else S = iTime(NULL,p[jj+1],(iBarShift(NULL,p[jj+1],CurStart,FALSE)+BarAnaliz));
      F=prevS;
      prevS=S;
      St=iBarShift(NULL,p[jj],CurStart,FALSE);
      Fin=iBarShift(NULL,p[jj],F,FALSE);

      if(St==0 && Fin==0)  return(0);
      sdv=(iBarShift(NULL,p[jj],S,FALSE))-St-7;
      if(jj!=8) {ArrShirina(St,Fin,sdv,p[jj]); }//Print("1111111111  ",p[jj],"   ", St,"   ", Fin,"   ",(iBarShift(NULL,p[jj],S,FALSE))-St-7);}
      else  {ArrShirina(St,Fin,0,p[jj]);}// Print("888888888  ",p[jj],"   ", St,"   ", Fin);}
      lastmin=Fin+1;
      if(jj==0) lmin=10000000;
      if(jj==0) premin=Shirina[Fin-St-1];
      // Print(Start,"  ",p[jj],"   - ",(iBarShift(NULL,p[jj],S,FALSE)),"   - ",Fin);
      if(Fin>iBarShift(NULL,p[jj],S,FALSE))
         for(i=Fin-1; i>(iBarShift(NULL,p[jj],S,FALSE))-1; i--)
           {
            int hhh=iBarShift(NULL,p[jj],S,FALSE);
            if(iTime(NULL,0,Bars-1)<=iTime(NULL,p[jj],i))
              {
               i3=iBarShift(NULL,0,iTime(NULL,p[jj],i),FALSE);
               for(i2=0;i2<=p[jj]/Period();i2++)
                 {
                  Shir[i3-i2]=Shirina[i-St];
                  if (i!=St && Shir[i3-i2]==0)
                  {
                   printf(" -  ");
                  }
                 }
              }
            if(Shirina[i-St]<lmin) {lmin=Shirina[i-St];lastmin=i;}
            
            if (i>St) if(Shirina[i-St]<=Shirina[i-St-1] && Shirina[i-St]<=Shirina[i-St+1])
               if(lastmin==i)
                 {
                  if(Shirina[i-St]<premin*filtr && Shirina[i-St]>MinShirina && Shirina[i-St]<MaxShirina)
                    {
                     if(i1>0) for(k=0; k<i1; k++)
                       {
                        if(Shirina[i-St]!=0) if((Kanals[k][0]/Shirina[i-St])<1.2 && (Kanals[k][0]/Shirina[i-St])>0.8) i1=k;
                       }
                     if(iTime(NULL,0,Bars-1)<=iTime(NULL,p[jj],i)) Vertikal[i3]=Shirina[i-St];
                     Kanals[i1][0]= Shirina[i-St];                            // Up
                     Kanals[i1][1]= i;                                        // i -   
                     Kanals[i1][2]= p[jj];                                    //
                     Kanals[i1][3]= CanalR[i-St];                             //yOptR
                     Kanals[i1][4]= CanalL[i-St];                             //yOptL
                     if((i-St)*p[jj]!=0) Kanals[i1][5]=(CanalR[i-St]-CanalL[i-St])/((i-St)*p[jj]);  //  
                     Kanals[i1][6]= (i-St);                                   //  
                     Kanals[i1][7]= ShirinaU[i-St];                           // Up
                     Kanals[i1][8]= ShirinaD[i-St];                           // Down
                     premin=Shirina[i-St];
                     i1++;
                    }
                 }
           }

     }
   return(i1);
  }
//////////////////////////////////////////////////////////////////////
double ArrShirina(int Start1,int Finish,int Sdvig,int per) //       Start1  Finish
  {
   Shirina[0]=0;
   if(Sdvig<0) Sdvig=0;
   yOptR=iOpen(NULL,per,Start1);

   int d,i1,i;
   double dC,dR,dL;
   int p1=0;
   int lnz=Sdvig;
//Print("Start  ",Start1,"Finish   ",Finish);
   for(i=(1+Sdvig); i<(Finish-Start1); i++)
     {
      //x2 = iTime(NULL,per,i);
      if(tochnost!=0) p1=(int)MathFloor((i-1)/tochnost);
      i=i+p1;
      Shirina[i]=MinCanal2(Start1,i+Start1,per);
      if(Shirina[i]<1) Print(per," ",Start1," ",i+Start1);

      if(maxmin==true)
        {
         if( k_shirina*Shirina[i]<curdeltaMax/Point) ShirinaU[i]=(curdeltaMax/Point+k_shirina*Shirina[i])/2; else ShirinaU[i]=curdeltaMax/Point;
         if(-k_shirina*Shirina[i]>curdeltaMin/Point) ShirinaD[i]=(curdeltaMin/Point-k_shirina*Shirina[i])/2; else ShirinaD[i]=curdeltaMin/Point;
        }
      CanalL[i]  = yOptL;
      CanalR[i]  = yOptR;
      d=i-lnz;
      if(d!=0) 
        {
         dC=(Shirina[i]-Shirina[lnz])/d;
         dR=(CanalR[i]-CanalR[lnz])/d;
         dL=(CanalL[i]-CanalL[lnz])/d;
        }
      else {dC=0;dR=0; dL=0;}
      if(d>1)
         for(i1=1;i1<d;i1++)
           {
            Shirina[lnz+i1] = Shirina[lnz+i1-1]+dC;
            CanalL[lnz+i1]  = CanalL[lnz+i1-1]+dL;
            CanalR[lnz+i1]  = CanalR[lnz+i1-1]+dR;
           }
      lnz=i;
     }
   return(0);
  }
///////////////////////////////////////////////////////
double MinCanal2(int xR,int xL,int per)
  {
   int n,p3,p2=xL-xR;
   double j1,j2,j3,d;

   p3=2*p2+1;
   j1 = p3 + 1;
   j2 = p3*(p3+1)/2;
   j3 = p3*(p3+1)*(2*p3+1)/6;


   if(prevxR!=xR || prevper!=per)
     {
      prevp=0;
      sum1=0;
      sum2=0;
     }

   for(n=prevp; n<=p2; n++)
     {
      sum2+=iHigh(NULL,per,n+xR)+iLow(NULL,per,n+xR);
     
      if (iOpen(NULL,per,n+xR)>=iClose(NULL,per,n+xR)) 
             sum1+=iHigh(NULL,per,n+xR)*2*n+iLow(NULL,per,n+xR)*(2*n+1);
        else
             sum1+=iLow(NULL,per,n+xR)*2*n+iHigh(NULL,per,n+xR)*(2*n+1);
     }

   prevxR=xR;
   prevp=p2+1;
   prevper=per;
   d=(j2*sum2-j1*sum1)/(j2*j2-j1*j3);
   yOptR = (sum1-j3*d)/j2;
   yOptL = d*2*p2+yOptR;

   return(SumPlus2(xL,xR,yOptR,yOptL,per)/(p2+1));
  }
///////////////////////////////////////////////////////

double SumPlus2(int xL1,int xR1,double yR1,double yL1,int per)
  {
   double curLinePrice,curdelta,curdeltaH,curdeltaL,delta=0;
   curdeltaMax=-100000;
   curdeltaMin=100000;
   int i = xR1;
   if(xL1==xR1)return(0);
   delta = (yL1-yR1)/(xL1-xR1);
   curLinePrice = yR1;
   sumPlus=0;
   while(i<=xL1)
     {
      curdelta=iOpen(NULL,per,i)-curLinePrice;
      curdeltaH = iHigh(NULL,per,i) - curLinePrice;
      curdeltaL = iLow(NULL,per,i) - curLinePrice;
      if(curdeltaMax<curdeltaH) curdeltaMax=curdeltaH;
      if(curdeltaMin>curdeltaL) curdeltaMin=curdeltaL;
      if(curdelta>0) sumPlus=sumPlus+curdelta;
      curLinePrice=curLinePrice+delta;
      i++;
     }
   return(sumPlus/Point);
  }
////////////////////////////////////////////////////////////////////////////////////
void LoadHist()
  {
   int iPeriod[9];
   iPeriod[0]=1;
   iPeriod[1]=5;
   iPeriod[2]=15;
   iPeriod[3]=30;
   iPeriod[4]=60;
   iPeriod[5]=240;
   iPeriod[6]=1440;
   iPeriod[7]=10080;
   iPeriod[8]=43200;
   for(int iii=0;iii<9;iii++)
     {
      datetime open=iTime(Symbol(),iPeriod[iii],0);
      //datetime open = MarketInfo(Symbol(),MODE_TIME);
      int error=GetLastError();
      //Comment("");
      while(error==4066)
        {
         //MessageBox("       ,        ","!!!",1);
         Comment("      ",iPeriod[iii]," ,        ");
         Sleep(10000);
         open = iTime(Symbol(), iPeriod[iii], 0);
         error=GetLastError();
        }
     }
  }
//+------------------------------------------------------------------+
